Index: MLXMANIFEST
===================================================================
--- MLXMANIFEST	(revision 82)
+++ MLXMANIFEST	(revision 105)
@@ -7,13 +7,14 @@
 library/pprint.pyc	9852	6b4724e14285c257116655b1d4ba6db1
 library/email/charset.pyc	13200	771aee9802116e673d08b44bc0450f99
-library/glib/_glib.pyc	555	dd3531d5a05abd904cbcbe9c63a6aeb7
-library/gtk/_gtk.pyc	549	b83a0fb41638340669ce2b745320de37
+library/glib/_glib.pyc	555	8ceef998474405daa266c18f0255427e
+library/gtk/_gtk.pyc	549	326adf7f2054e559a1d951d421a355ea
 library/xml/__init__.pyc	1058	8f77f254e8c6db7a3b6d9930a686d787
 library/encodings/cp858.pyc	7591	02054a0b8e91b9758826eb70cddf096f
+library/mlx/pirep.pyc	3976	2a1f80d754390ad4460a567b0f51e2cb
 library/encodings/cp1254.pyc	2678	17ff2ac86f90886d5c73ed789f0499f3
 library/encodings/palmos.pyc	2876	9284ad53dcfd82dfae0a79923b1cf91d
 library/encodings/unicode_internal.pyc	2022	1e902113491e0c334b44deb0c8940e01
 library/encodings/zlib_codec.pyc	4308	319c9073aff840436a03cc1fa0b08fb5
-library/mlx/gui/gui.pyc	15867	2a1bef52c00dc48a9087209f412299f7
+library/mlx/gui/gui.pyc	24323	56ed0b0e04d06b92ffddaa73939a6a93
 library/repr.pyc	5045	82f0d89c685c3dacd941e01e4b2f31ef
 library/textwrap.pyc	11410	f7bfc56465324edf71b977397a4c7c0b
@@ -26,5 +27,5 @@
 library/encodings/mbcs.pyc	1883	2213911a7dd0deada6799b63e18b695b
 library/mlx/update.pyc	16119	702d50ed1b791cc2425d6986aeaf2d47
-library/pyuipc.pyc	543	db67247919f5a75448fdbb8ec87767df
+library/pyuipc.pyc	543	7aee88b82d1d878cf2a043b2d1566b68
 library/encodings/cp932.pyc	1638	e060301989634a7fb30ded375011cb09
 library/UserDict.pyc	7920	c72896a5a8a1a3d93fa6ba23c50a04b0
@@ -34,5 +35,5 @@
 library/getpass.pyc	4627	7c01bf3df2e0074115d1a484629b4c63
 library/freetype6.dll	538324	fe5ec4b2a07d2c20a4cd3aa09ce0c571
-library/gobject/_gobject.pyc	573	27e7c63c807f6bd7e169700d6ffa214d
+library/gobject/_gobject.pyc	573	37c23bf2a30f7ee16c07683f387da411
 library/encodings/mac_cyrillic.pyc	2745	c17fd9fd5bc854dd5ffe80076e1eeb02
 library/encodings/utf_7.pyc	1747	2beeb059236527197d6c640396476ce8
@@ -54,5 +55,5 @@
 library/abc.pyc	5923	c45df4ceeb48b9c74dcb8bc4d5928924
 library/os.pyc	25063	7c7eee513ae4238d1b2c16af719c10a0
-mlxupdate.exe	19456	bfecc23e09218b4911bb30390607ca26
+mlxupdate.exe	19456	d16766a21f788d440fae2160132421e2
 library/uu.pyc	4212	0073b65d26a6092e4e177c7763058fa4
 library/encodings/iso8859_1.pyc	2678	f09ec3b7f6a348cbd7f7286b60572bd0
@@ -62,7 +63,7 @@
 library/encodings/uu_codec.pyc	4646	5282a5fcb676851224d2924aa3e48a9e
 library/pangocairo.pyd	17920	5fc69a7d29a6d3127710c64de440daa4
-library/pangocairo.pyc	555	157bae3089bc16f697752fa52a7e9474
+library/mlx/gui/info.pyc	5160	3ea2b08e005049ae49670336bc25ba43
 library/encodings/unicode_escape.pyc	1996	32990583f1caf874e556087da7b92971
-runmlx.exe	64000	c04b46e9b6e9ad38b092c90fb2ee3ebc
+runmlx.exe	64000	f9727c08c891ddc6f69aa361020ffe22
 library/weakref.pyc	13028	5d1c14275f47e8cf6d40bc6877fde976
 library/unittest/loader.pyc	10884	591a785be23fba35582ce33bdd3d7acd
@@ -71,5 +72,5 @@
 library/libgmodule-2.0-0.dll	36986	b0b2396fc6413016a45a5e8ca2ea8152
 library/encodings/cp866.pyc	8103	f36418dcf93b17b3ced63bd544f44159
-library/gio/_gio.pyc	549	bd2571576db2d4fe9867a6e9d6fba295
+library/gio/_gio.pyc	549	7dc22df359e3b890fcd0e6eb6f5df5fc
 library/encodings/cp437.pyc	7874	63f1278c0a66129c6fb4f504d6b61b66
 library/unittest/result.pyc	7444	aefbb3cc79c0ff17787ce84faed7f5e8
@@ -81,5 +82,5 @@
 library/mimetools.pyc	7837	c9accd6ef795bf71c90630be0161cadc
 library/libgdk_pixbuf-2.0-0.dll	285194	e4c64b0e7e4c6606f3973a16c0c1ee84
-library/mlx/web.pyc	18899	057390b8e3659355f17da516d505ce69
+library/mlx/web.pyc	22429	0263287119b99b8dd1bc86b73e249e34
 library/encodings/quopri_codec.pyc	3365	01342d4d2735bcbfeb333d784297547a
 library/collections.pyc	23430	3b68687320ddc080ef5c92404487a161
@@ -102,7 +103,7 @@
 library/mimetypes.pyc	17806	927ce6a7079707aaee925e855ed23454
 library/_hashlib.pyd	287232	a1a18de0644f481749fcbcf26005eeaf
-library/mlx/fs.pyc	5574	f85e215becf8c1855ac416ad051cf75a
+library/mlx/fs.pyc	5672	39e352275317ddec1ecd3e03e2c2535d
 library/socket.pyc	15488	35f8eb455d6d8df8e19826d1dd7193f2
-library/_hashlib.pyc	549	97f3232dda273b9acb63b19c7b2b2d1f
+library/_hashlib.pyc	549	4d0df2bd38079a60e931fff6500a5371
 library/libpng14-14.dll	230529	f3a15497e25baaa721f96638d7a4d2f8
 library/copy.pyc	11674	30d1745c5e38ab170f8a0486fbebf305
@@ -123,9 +124,9 @@
 library/encodings/mac_latin2.pyc	4717	564dbaf5c296a147203eb821dc2466ba
 library/quopri.pyc	6352	87c42d94f753dd4c8a761cfa79453bb8
-library/mlx/flight.pyc	3786	decd7dc66263aae29886da0658e4b93e
+library/mlx/flight.pyc	6395	23bdb06b4802bc4f6304746ac2b22615
 library/encodings/idna.pyc	6124	6d67198be2b194c4c0acf48e2f1473ac
 library/encodings/mac_farsi.pyc	2659	df751a61510129a25f7a43ae3aace4f7
 library/encodings/latin_1.pyc	2111	52427573ccbfd06220b67d5a9dd1376e
-library/mlx/gui/common.pyc	2658	6763b0272293acf625fa8f38f34dea1c
+library/mlx/gui/common.pyc	5101	88b3eaa41ec71e7db40127440e5717ef
 library/encodings/gb2312.pyc	1646	466ac29d34de1ad4b3d299ca834e28d9
 library/encodings/iso2022_jp_3.pyc	1699	ee1c3aa11bbe19eeb4deafa238563133
@@ -136,6 +137,6 @@
 library/encodings/utf_32.pyc	5336	912103fef3db6edc29a35dd0cfb5c5b9
 library/subprocess.pyc	38648	c9f749db06dfc9fb32079de51d6efd01
-library/mlx/acft.pyc	21990	339c555f2c26416b1df44b360d7160a1
-library/pyexpat.pyc	546	bfc4ec9d9f6e8f3e4cfe55b84183ae5a
+library/mlx/acft.pyc	24104	dbea5af1ab9283ad688d15186d28e4cc
+library/pyexpat.pyc	546	b3845d8671675e66175a9923ab6b9d3c
 library/encodings/cp865.pyc	7868	7d40a7ba053ac23339218be8799e5397
 library/nturl2path.pyc	1755	7835082f2dd6806f99cc25bed13ff7dc
@@ -147,6 +148,6 @@
 library/mlx/gui/statusicon.pyc	5415	e513861d3ea922ac8230939c5ecd2b29
 library/email/generator.pyc	9877	f387feb2b59e121f7b0ece209e8875ae
-library/cairo/_cairo.pyc	561	237950ef58afa5cc1eaed8cd9a1547ef
-library/mlx/gui/flight.pyc	55346	16348ff9b61640741bd1fd5b5cc267b0
+library/cairo/_cairo.pyc	561	7c08add7261ed2de1b603367a626e332
+library/mlx/gui/flight.pyc	70983	c25de85e0bd97ec314da8be6250fcc6b
 library/urllib.pyc	48771	4d4b07040a1d0b0b31f5779eeb01c269
 library/encodings/cp864.pyc	7999	ca90afae086cb6b8f69b8419cc3cd1cb
@@ -164,5 +165,5 @@
 library/email/mime/__init__.pyc	110	bae57a199e3d0998a1364b9fbae8b3cd
 library/ftplib.pyc	32043	5a1925388a0874e459aed6891f4cf0c1
-library/select.pyc	543	beb01e3c816904ceb286ed1d1f547c75
+library/select.pyc	543	bf214a59a9221cec1287545e65d597ee
 library/libglib-2.0-0.dll	1242929	18e88b04da123bf05b07ff60a4e96654
 library/encodings/cp775.pyc	7888	25bf7dd514dff294aa02d5119399b2b7
@@ -198,5 +199,5 @@
 library/keyword.pyc	2063	4d5bab044f614cfdabe89011cd3d7375
 library/_socket.pyd	38400	5d273be76603399e88cf57f2605004bf
-library/_socket.pyc	546	41bb788cb1e47bc9d8984066eee58bbd
+library/_socket.pyc	546	50f6665c3acfc1e70d080c3d2b00e716
 library/encodings/hex_codec.pyc	3520	a8b8d5b7c8810379c7007bcbc253951c
 library/mlx/checks.pyc	38983	b846048258771fc43714510c400e5f05
@@ -210,5 +211,5 @@
 library/libfontconfig-1.dll	279059	dd583bedc5efe7bbd21a8ef107dec88d
 library/heapq.pyc	13109	20df4990fffba06bbdda995ce7466caa
-library/bz2.pyc	534	54e3a0a03a99ccbca381a741e8ca3363
+library/bz2.pyc	534	ac930c54e0d9f711dda9325f63e770a9
 library/xml/sax/expatreader.pyc	13563	4f64c0efb2f1f8dbba84cdb5c6036f2d
 library/email/utils.pyc	8840	a7be428df6fddee6121cfce55382d1f8
@@ -218,8 +219,8 @@
 w9xpopen.exe	49664	e6895233ad1e6f3dcdd04c7c26b0e7c0
 library/encodings/cp1250.pyc	2676	c92e287a2aa6a1c924df287d826aa3b7
-library/mlx/gui/monitor.pyc	9361	ad9c92e319472fe0a1f19fc2818f793a
+library/mlx/gui/monitor.pyc	9639	8a0ad07cbf8e1a40b0697a9fa8b07bc6
 library/_ssl.pyd	720896	90826a140137efd0d806038828e16f8e
 library/zlib1.dll	100352	d90dad5eea33a178bac56fff2847d4c2
-library/pango.pyc	540	c11d36d057a7e3ba52a70fb497aca065
+library/pango.pyc	540	fa71dd1220020d2054a490bfd717394e
 library/encodings/cp1026.pyc	2653	ced5dd0cc0da378b0968f82309b9bcfb
 library/encodings/iso8859_10.pyc	2693	5e6cc8f721486ddbc1c99da285e13191
@@ -228,9 +229,9 @@
 library/pango.pyd	111616	c934763bdf125c3dc92b56db817001d4
 library/encodings/koi8_r.pyc	2700	fff1b35002b9e938b7ea6fd0fbe824ae
-library/mlx/gui/statusbar.pyc	4542	d55ee5f5dd3af30dbe1b0695a2a2f878
+library/mlx/gui/statusbar.pyc	4542	3aba70beb55b8e66eb8378b334760116
 library/encodings/utf_32_le.pyc	1747	8679f9c7cca87ad540b30c176ef914de
 library/intl.dll	152489	eb2d4c4d4a527bc88a69a16cc99afcf5
 library/pygtk.pyc	1914	814f68243c9fd447c0aa02326f1ead2b
-library/mlx/const.pyc	2113	bf7e5d28987519a3d572a91c01b07a3d
+library/mlx/const.pyc	2538	9a0f0413316cf7fd0266cda3bab3fbd5
 library/libpangowin32-1.0-0.dll	108945	d07f128828225b7cc38e9e590eb3ba8a
 library/email/errors.pyc	3229	cdb78ab237e195ad69f059128bc03b1d
@@ -238,6 +239,6 @@
 library/linecache.pyc	3091	666e6f81b0ea9a7637f8068493f738d5
 library/encodings/iso8859_11.pyc	2787	a31e6d0d34e35259d7183cc9437eacca
-library/mlx/fsuipc.pyc	47275	a708ab51d6ad050bf603438de0029625
-library/win32api.pyc	549	acb63cca8cf860b7412bb6cdd39729d9
+library/mlx/fsuipc.pyc	47578	f0419e74f81bce021fb0114d67ef8be4
+library/win32api.pyc	549	d990346c790702c3df27b1c2b0655c99
 library/posixpath.pyc	10734	d694316c239784c444b252c801c97efa
 library/encodings/mac_iceland.pyc	2738	dfff28ea5edfda00df56b4ab9a35bc59
@@ -250,5 +251,5 @@
 library/encodings/iso8859_13.pyc	2696	f901ae0bbcfbb78f0c1783e89b2e2dc5
 library/encodings/cp857.pyc	7611	1b46c8959ac097b73e1c680d464cdc32
-library/_ssl.pyc	537	01546d778c2f9fc9f11d5e9cfd13a1c1
+library/_ssl.pyc	537	b371dd1120420b9ec303622a01b4e12c
 library/xml/sax/saxutils.pyc	12382	32ed045b3b520234ebea6a508a6569fe
 library/encodings/shift_jis.pyc	1670	afdb08e9b2888f86fc71010edcf057b4
@@ -262,5 +263,5 @@
 library/httplib.pyc	35251	2ac8119676b4b02ed78fd020ea423de5
 library/sre_compile.pyc	10792	c58f94fbee661f3bb0c59ecc13c0416e
-library/mlx/pyuipc_sim.pyc	39806	cc8a65ccb57e25a84215b6a2819220f9
+library/mlx/pyuipc_sim.pyc	41697	a47b8ed8242a7e590758835e8c5a8d1d
 python27.dll	2206720	f8f39495ed4a813e8f3049a4b9f5cff4
 library/encodings/iso8859_9.pyc	2678	88880e046738ebd2012c8034416a9adf
@@ -282,8 +283,8 @@
 library/encodings/cp1252.pyc	2676	b4c43cc72650c911cf3654dbaf565df9
 library/unicodedata.pyd	688128	c856c31a03dc892e4f2aee93d0bfee44
-library/unicodedata.pyc	558	42febdbfea7e2b8598a8494736672f16
+library/unicodedata.pyc	558	e312a244b052a43853938591559cb111
 library/gtk/deprecation.pyc	3104	2e6c9eef82dfa8aa3beb05abd3e274a4
 library/mlx/config.pyc	4783	6b85e2c37d8d20276bc87ea7a72805a2
-library/atk.pyc	534	ac972127e7239b5922ebb40cb6c1fb47
+library/atk.pyc	534	c51268cb675f536d08303e8c42a2badb
 library/gio._gio.pyd	263168	acb8c95fdc391079bebdf7d8685b0dbc
 library/encodings/cp861.pyc	7868	c97a8970ce4d9f40cbafbea6576fbdca
@@ -309,9 +310,9 @@
 library/libpangoft2-1.0-0.dll	815421	1dbfead06e26edb81f0849490210e3ff
 library/inspect.pyc	38547	836f659fad54f5ee7e8f9d565003aacd
-library/mlx/util.pyc	99	fee55c2660c52ab045d2e0e1826c039b
+library/mlx/util.pyc	4209	49d5908a2ed39b53fb813a12d1ba1b09
 library/mlx/gui/__init__.pyc	107	22f268cac1c5be2f3a058810b6caead3
 library/cairo._cairo.pyd	69632	46d708899832abc0123c4e9cb4f61d5d
 library/doctest.pyc	79210	620422f95e18417ff5f8440534a71e91
-library/mlx/logger.pyc	3817	2403cd70086631693aa890ca202a22a4
+library/mlx/logger.pyc	4613	86ad17a271b4710d049e7c34dc3d4169
 library/glib/option.pyc	11891	bd90183c75d8f473ecf653e3d63a27f9
 library/encodings/ascii.pyc	2081	a5fffd04734740386629fdba1113d585
@@ -335,2 +336,3 @@
 library/encodings/iso2022_jp_ext.pyc	1715	97eda1c1468f65445951b0bf23a89570
 library/encodings/utf_8_sig.pyc	4625	1b1405db186e5819fa271ff96c1ca2c5
+library/pangocairo.pyc	555	9208abb19bae9a96f7925367aea09ea8