Index: src/mlx/gui/gui.py
===================================================================
--- src/mlx/gui/gui.py	(revision 108)
+++ src/mlx/gui/gui.py	(revision 110)
@@ -585,5 +585,5 @@
         menuBar = gtk.MenuBar()
         
-        fileMenuItem = gtk.MenuItem("File")
+        fileMenuItem = gtk.MenuItem(xstr("menu_file"))
         fileMenu = gtk.Menu()
         fileMenuItem.set_submenu(fileMenu)
@@ -592,12 +592,13 @@
         quitMenuItem = gtk.ImageMenuItem(gtk.STOCK_QUIT)
         quitMenuItem.set_use_stock(True)
+        quitMenuItem.set_label(xstr("menu_file_quit"))
         quitMenuItem.add_accelerator("activate", accelGroup,
-                                     ord("q"), CONTROL_MASK,
-                                     ACCEL_VISIBLE)
+                                     ord(xstr("menu_file_quit_key")),
+                                     CONTROL_MASK, ACCEL_VISIBLE)
         quitMenuItem.connect("activate", self._quit)
         fileMenu.append(quitMenuItem)
 
 
-        viewMenuItem = gtk.MenuItem("View")
+        viewMenuItem = gtk.MenuItem(xstr("menu_view"))
         viewMenu = gtk.Menu()
         viewMenuItem.set_submenu(viewMenu)
@@ -605,20 +606,20 @@
 
         self._showMonitorMenuItem = gtk.CheckMenuItem()
-        self._showMonitorMenuItem.set_label("Show _monitor window")
+        self._showMonitorMenuItem.set_label(xstr("menu_view_monitor"))
         self._showMonitorMenuItem.set_use_underline(True)
         self._showMonitorMenuItem.set_active(False)
         self._showMonitorMenuItem.add_accelerator("activate", accelGroup,
-                                                  ord("m"), CONTROL_MASK,
-                                                  ACCEL_VISIBLE)
+                                                  ord(xstr("menu_view_monitor_key")),
+                                                  CONTROL_MASK, ACCEL_VISIBLE)
         self._showMonitorMenuItem.connect("toggled", self._toggleMonitorWindow)
         viewMenu.append(self._showMonitorMenuItem)
 
         showDebugMenuItem = gtk.CheckMenuItem()
-        showDebugMenuItem.set_label("Show _debug log")
+        showDebugMenuItem.set_label(xstr("menu_view_debug"))
         showDebugMenuItem.set_use_underline(True)
         showDebugMenuItem.set_active(False)
         showDebugMenuItem.add_accelerator("activate", accelGroup,
-                                          ord("d"), CONTROL_MASK,
-                                          ACCEL_VISIBLE)
+                                          ord(xstr("menu_view_debug_key")),
+                                          CONTROL_MASK, ACCEL_VISIBLE)
         showDebugMenuItem.connect("toggled", self._toggleDebugLog)
         viewMenu.append(showDebugMenuItem)
@@ -631,5 +632,5 @@
             label = gtk.Label(xstr("tab_debug_log"))
             label.set_use_underline(True)
-            label.set_tooltip_text("Log with debugging information.")        
+            label.set_tooltip_text(xstr("tab_debug_log_tooltip"))        
             self._debugLogPage = self._notebook.append_page(self._debugLogWidget, label)
             self._notebook.set_current_page(self._debugLogPage)
@@ -678,6 +679,6 @@
                                        type = MESSAGETYPE_QUESTION,
                                        buttons = BUTTONSTYPE_YES_NO,
-                                       message_format =
-                                       "Are you sure to quit the logger?")
+                                       message_format = xstr("quit_question"))
+
             dialog.set_title(WINDOW_TITLE_BASE)
             result = dialog.run()
Index: src/mlx/i18n.py
===================================================================
--- src/mlx/i18n.py	(revision 108)
+++ src/mlx/i18n.py	(revision 110)
@@ -124,4 +124,15 @@
     def initialize(self):
         """Initialize the strings."""
+        self.add("menu_file", "File")
+        self.add("menu_file_quit", "_Quit")
+        self.add("menu_file_quit_key", "q")
+        self.add("quit_question", "Are you sure to quit the logger?")
+
+        self.add("menu_view", "View")
+        self.add("menu_view_monitor", "Show _monitor window")
+        self.add("menu_view_monitor_key", "m")
+        self.add("menu_view_debug", "Show _debug log")
+        self.add("menu_view_debug_key", "d")
+        
         self.add("tab_flight", "_Flight")
         self.add("tab_flight_tooltip", "Flight wizard")
@@ -132,4 +143,5 @@
                  "The log of your flight that will be sent to the MAVA website")
         self.add("tab_debug_log", "_Debug log")
+        self.add("tab_debug_log_tooltip", "Log with debugging information.")
         self.add("tab_help", "_Help")
         self.add("tab_gates", "_Gates")
@@ -404,4 +416,15 @@
     def initialize(self):
         """Initialize the strings."""
+        self.add("menu_file", "Fájl")
+        self.add("menu_file_quit", "_Kilépés")
+        self.add("menu_file_quit_key", "k")
+        self.add("quit_question", "Biztosan ki akarsz lépni?")
+
+        self.add("menu_view", "Nézet")
+        self.add("menu_view_monitor", "Mutasd a _monitor ablakot")
+        self.add("menu_view_monitor_key", "m")
+        self.add("menu_view_debug", "Mutasd a _debug naplót")
+        self.add("menu_view_debug_key", "d")
+        
         self.add("tab_flight", "_Járat")
         self.add("tab_flight_tooltip", "Járat varázsló")
@@ -412,4 +435,6 @@
                  "A járat naplója, amit majd el lehet küldeni a MAVA szerverére")
         self.add("tab_debug_log", "_Debug napló")
+        self.add("tab_debug_log_tooltip",
+                 "Hibakereséshez használható információkat tartalmazó napló.")
         self.add("tab_help", "_Segítség")
         self.add("tab_gates", "_Kapuk")        