Index: src/mlx/gui/info.py
===================================================================
--- src/mlx/gui/info.py	(revision 102)
+++ src/mlx/gui/info.py	(revision 111)
@@ -3,18 +3,22 @@
 from common import *
 
+from mlx.i18n import xstr
 import mlx.const as const
 
 class FlightInfo(gtk.VBox):
     """The flight info tab."""
-    _delayCodes = [ (const.DELAYCODE_LOADING, "L_oading problems"),
-                    (const.DELAYCODE_VATSIM, "_VATSIM problem"),
-                    (const.DELAYCODE_NETWORK, "_Net problems"),
-                    (const.DELAYCODE_CONTROLLER, "Controller's _fault"),
-                    (const.DELAYCODE_SYSTEM, "S_ystem crash/freeze"),
-                    (const.DELAYCODE_NAVIGATION, "Navi_gation problem"),
-                    (const.DELAYCODE_TRAFFIC, "T_raffic problems"),
-                    (const.DELAYCODE_APRON, "_Apron navigation problem"),
-                    (const.DELAYCODE_WEATHER, "_Weather problems"),
-                    (const.DELAYCODE_PERSONAL, "_Personal reasons") ]
+    @staticmethod
+    def _delayCodes():
+        """Get an array of delay codes."""
+        return [ (const.DELAYCODE_LOADING, xstr("info_delay_loading")),
+                 (const.DELAYCODE_VATSIM, xstr("info_delay_vatsim")),
+                 (const.DELAYCODE_NETWORK, xstr("info_delay_net")),
+                 (const.DELAYCODE_CONTROLLER, xstr("info_delay_atc")),
+                 (const.DELAYCODE_SYSTEM, xstr("info_delay_system")),
+                 (const.DELAYCODE_NAVIGATION, xstr("info_delay_nav")),
+                 (const.DELAYCODE_TRAFFIC, xstr("info_delay_traffic")),
+                 (const.DELAYCODE_APRON, xstr("info_delay_apron")),
+                 (const.DELAYCODE_WEATHER, xstr("info_delay_weather")),
+                 (const.DELAYCODE_PERSONAL, xstr("info_delay_personal")) ]
     
     @staticmethod
@@ -61,8 +65,9 @@
         commentsBox = gtk.HBox()
 
-        (frame, self._comments) = FlightInfo._createCommentArea("_Comments")
+        (frame, self._comments) = FlightInfo._createCommentArea(xstr("info_comments"))
         commentsBox.pack_start(frame, True, True, 8)
 
-        (frame, self._flightDefects) = FlightInfo._createCommentArea("Flight _defects")
+        (frame, self._flightDefects) = \
+             FlightInfo._createCommentArea(xstr("info_defects"))
         commentsBox.pack_start(frame, True, True, 8)
 
@@ -70,5 +75,5 @@
         self.pack_start(self._commentsAlignment, True, True, 8)
 
-        frame = gtk.Frame(label = "Delay codes")
+        frame = gtk.Frame(label = xstr("info_delay"))
         label = frame.get_label_widget()
         label.set_use_underline(True)
@@ -86,5 +91,5 @@
 
         self._delayCodeWidgets = []
-        for (_code, label) in FlightInfo._delayCodes:
+        for (_code, label) in FlightInfo._delayCodes():
             button = gtk.CheckButton(label)
             button.set_use_underline(True)
Index: src/mlx/i18n.py
===================================================================
--- src/mlx/i18n.py	(revision 110)
+++ src/mlx/i18n.py	(revision 111)
@@ -405,4 +405,23 @@
                  "you may try again later. Or it can be a bug;\n" \
                  "see the debug log for more information.")
+
+        # C D
+        
+        self.add("info_comments", "_Comments")
+        self.add("info_defects", "Flight _defects")
+        self.add("info_delay", "Delay codes")
+
+        # O V N E Y T R A W P
+        
+        self.add("info_delay_loading", "L_oading problems")
+        self.add("info_delay_vatsim", "_VATSIM problem")
+        self.add("info_delay_net", "_Net problems")
+        self.add("info_delay_atc", "Controll_er's fault")
+        self.add("info_delay_system", "S_ystem crash/freeze")
+        self.add("info_delay_nav", "Naviga_tion problem")
+        self.add("info_delay_traffic", "T_raffic problems")
+        self.add("info_delay_apron", "_Apron navigation problem")
+        self.add("info_delay_weather", "_Weather problems")
+        self.add("info_delay_personal", "_Personal reasons")
                  
 #------------------------------------------------------------------------------
@@ -702,4 +721,23 @@
                  "újra próbálkozhatsz. Lehet azonban hiba is a loggerben:\n" \
                  "részletesebb információt találhatsz a debug naplóban.")
+
+        # M A 
+
+        self.add("info_comments", "_Megjegyzések")
+        self.add("info_defects", "Hib_ajelenségek")
+        self.add("info_delay", "Késés kódok")
+
+        # B V H Y R G F E P Z
+                 
+        self.add("info_delay_loading", "_Betöltési problémák")
+        self.add("info_delay_vatsim", "_VATSIM probléma")
+        self.add("info_delay_net", "_Hálózati problémák")
+        self.add("info_delay_atc", "Irán_yító hibája")
+        self.add("info_delay_system", "_Rendszer elszállás/fagyás")
+        self.add("info_delay_nav", "Navi_gációs probléma")
+        self.add("info_delay_traffic", "_Forgalmi problémák")
+        self.add("info_delay_apron", "_Előtér navigációs probléma")
+        self.add("info_delay_weather", "Időjárási _problémák")
+        self.add("info_delay_personal", "S_zemélyes okok")
                  
 #------------------------------------------------------------------------------