Index: src/mlx/config.py
===================================================================
--- src/mlx/config.py	(revision 123)
+++ src/mlx/config.py	(revision 124)
@@ -12,4 +12,10 @@
 configPath = os.path.join(os.path.expanduser("~"),
                           "mlx.config" if os.name=="nt" else ".mlxrc")
+
+#-------------------------------------------------------------------------------
+
+if os.name=="nt":
+    _languageMap = { "en_GB" : "eng",
+                     "hu_HU" : "hun" }
 
 #-------------------------------------------------------------------------------
@@ -172,12 +178,12 @@
         import locale
         if self._language:
-            os.environ["LANGUAGE"] = self._language
-            os.environ["LANG"] = self._language + ".UTF-8"
-            os.environ["LC_MESSAGES"] = self._language + ".UTF-8"
-            os.environ["LC_COLLATE"] = self._language + ".UTF-8"
-            os.environ["LC_CTYPE"] = self._language + ".UTF-8"
-
-            locale.setlocale(locale.LC_ALL, (self._language,
-                                             locale.getpreferredencoding()))
+            if os.name=="nt":
+                if self._language in _languageMap:
+                    locale.setlocale(locale.LC_ALL, _languageMap[self._language])
+                else:
+                    locale.setlocale(locale.LC_ALL, "")
+            else:
+                locale.setlocale(locale.LC_ALL, (self._language,
+                                                 locale.getpreferredencoding()))
             return self._language
         else:
Index: src/mlx/gui/common.py
===================================================================
--- src/mlx/gui/common.py	(revision 123)
+++ src/mlx/gui/common.py	(revision 124)
@@ -24,7 +24,7 @@
     MESSAGETYPE_QUESTION = gtk.MESSAGE_QUESTION
     MESSAGETYPE_INFO = gtk.MESSAGE_INFO
-    BUTTONSTYPE_OK = gtk.BUTTONS_OK
-    BUTTONSTYPE_YES_NO = gtk.BUTTONS_YES_NO
+    RESPONSETYPE_OK = gtk.RESPONSE_OK
     RESPONSETYPE_YES = gtk.RESPONSE_YES
+    RESPONSETYPE_NO = gtk.RESPONSE_NO
     RESPONSETYPE_ACCEPT = gtk.RESPONSE_ACCEPT
     RESPONSETYPE_REJECT = gtk.RESPONSE_REJECT
@@ -49,7 +49,7 @@
     MESSAGETYPE_QUESTION = gtk.MessageType.QUESTION
     MESSAGETYPE_INFO = gtk.MessageType.INFO
-    BUTTONSTYPE_OK = gtk.ButtonsType.OK
-    BUTTONSTYPE_YES_NO = gtk.ButtonsType.YES_NO
+    RESPONSETYPE_OK = gtk.ResponseType.OK
     RESPONSETYPE_YES = gtk.ResponseType.YES
+    RESPONSETYPE_NO = gtk.ResponseType.NO
     RESPONSETYPE_ACCEPT = gtk.ResponseType.ACCEPT
     RESPONSETYPE_REJECT = gtk.ResponseType.REJECT
Index: src/mlx/gui/flight.py
===================================================================
--- src/mlx/gui/flight.py	(revision 122)
+++ src/mlx/gui/flight.py	(revision 124)
@@ -306,6 +306,6 @@
                 dialog = gtk.MessageDialog(parent = self._wizard.gui.mainWindow,
                                            type = MESSAGETYPE_ERROR,
-                                           buttons = BUTTONSTYPE_OK,
                                            message_format = xstr("login_invalid"))
+                dialog.add_button(xstr("button_ok"), RESPONSETYPE_OK)
                 dialog.set_title(WINDOW_TITLE_BASE)
                 dialog.format_secondary_markup(xstr("login_invalid_sec"))
@@ -315,6 +315,6 @@
             dialog = gtk.MessageDialog(parent = self._wizard.gui.mainWindow,
                                        type = MESSAGETYPE_ERROR,
-                                       buttons = BUTTONSTYPE_OK,
                                        message_format = xstr("login_failconn"))
+            dialog.add_button(xstr("button_ok"), RESPONSETYPE_OK)
             dialog.set_title(WINDOW_TITLE_BASE)
             dialog.format_secondary_markup(xstr("login_failconn_sec"))
@@ -523,6 +523,6 @@
             dialog = gtk.MessageDialog(parent = self._wizard.gui.mainWindow,
                                        type = MESSAGETYPE_ERROR,
-                                       buttons = BUTTONSTYPE_OK,
                                        message_format = xstr("gatesel_conflict"))
+            dialog.add_button(xstr("button_ok"), RESPONSETYPE_OK)
             dialog.set_title(WINDOW_TITLE_BASE)
             dialog.format_secondary_markup(xstr("gatesel_conflict_sec"))
@@ -1880,6 +1880,6 @@
         
         dialog = gtk.MessageDialog(parent = self._wizard.gui.mainWindow,
-                                   type = type, buttons = BUTTONSTYPE_OK,
-                                   message_format = messageFormat)
+                                   type = type, message_format = messageFormat)
+        dialog.add_button(xstr("button_ok"), RESPONSETYPE_OK)
         dialog.set_title(WINDOW_TITLE_BASE)
         if secondaryMarkup is not None:
@@ -2140,7 +2140,7 @@
             dialog = gtk.MessageDialog(parent = self.gui.mainWindow,
                                        type = MESSAGETYPE_ERROR,
-                                       buttons = BUTTONSTYPE_OK,
                                        message_format =
                                        xstr("fleet_update_failed"))
+            dialog.add_button(xstr("button_ok"), RESPONSETYPE_OK)
             dialog.set_title(WINDOW_TITLE_BASE)
             dialog.run()
Index: src/mlx/gui/gui.py
===================================================================
--- src/mlx/gui/gui.py	(revision 123)
+++ src/mlx/gui/gui.py	(revision 124)
@@ -581,6 +581,6 @@
             dialog = gtk.MessageDialog(parent = self.mainWindow,
                                        type = MESSAGETYPE_ERROR,
-                                       buttons = BUTTONSTYPE_OK,
                                        message_format = xstr("fleet_failed"))
+            dialog.add_button(xstr("button_ok"), RESPONSETYPE_ACCEPT)
             dialog.set_title(WINDOW_TITLE_BASE)
             dialog.run()
@@ -756,6 +756,8 @@
             dialog = gtk.MessageDialog(parent = self._mainWindow,
                                        type = MESSAGETYPE_QUESTION,
-                                       buttons = BUTTONSTYPE_YES_NO,
                                        message_format = xstr("quit_question"))
+
+            dialog.add_button(xstr("button_no"), RESPONSETYPE_NO)
+            dialog.add_button(xstr("button_yes"), RESPONSETYPE_YES)
 
             dialog.set_title(WINDOW_TITLE_BASE)
Index: src/mlx/gui/prefs.py
===================================================================
--- src/mlx/gui/prefs.py	(revision 123)
+++ src/mlx/gui/prefs.py	(revision 124)
@@ -19,9 +19,9 @@
                                           xstr("prefs_title"),
                                           gui.mainWindow,
-                                          DIALOG_MODAL,
-                                          (gtk.STOCK_CANCEL,
-                                           RESPONSETYPE_REJECT,
-                                           gtk.STOCK_OK,
-                                           RESPONSETYPE_ACCEPT))
+                                          DIALOG_MODAL)
+
+        self.add_button(xstr("button_cancel"), RESPONSETYPE_REJECT)
+        self.add_button(xstr("button_ok"), RESPONSETYPE_ACCEPT)
+        
         self._gui = gui
 
@@ -139,6 +139,6 @@
             dialog = gtk.MessageDialog(parent = self,
                                        type = MESSAGETYPE_INFO,
-                                       buttons = BUTTONSTYPE_OK,
                                        message_format = xstr("prefs_restart"))
+            dialog.add_button(xstr("button_ok"), RESPONSETYPE_OK)
             dialog.set_title(self.get_title())
             dialog.format_secondary_markup(xstr("prefs_language_restart_sec"))
@@ -199,6 +199,6 @@
             dialog = gtk.MessageDialog(parent = self,
                                        type = MESSAGETYPE_INFO,
-                                       buttons = BUTTONSTYPE_OK,
                                        message_format = xstr("prefs_update_auto_warning"))
+            dialog.add_button(xstr("button_ok"), RESPONSETYPE_OK)
             dialog.set_title(self.get_title())
             dialog.run()
Index: src/mlx/gui/update.py
===================================================================
--- src/mlx/gui/update.py	(revision 115)
+++ src/mlx/gui/update.py	(revision 124)
@@ -75,8 +75,8 @@
             gtk.Dialog(WINDOW_TITLE_BASE + " " + xstr("update_title"),
                        parentWindow,
-                       gtk.DialogFlags.MODAL if pygobject else gtk.DIALOG_MODAL,
-                       (gtk.STOCK_CANCEL, 0,
-                        gtk.STOCK_OK, 1))
-
+                       gtk.DialogFlags.MODAL if pygobject else gtk.DIALOG_MODAL)
+        sudoDialog.add_button(xstr("button_cancel"), 0)
+        sudoDialog.add_button(xstr("button_ok"), 1)
+                       
         infoLabelAlignment = gtk.Alignment(xalign = 0.5, xscale = 0.1)
         infoLabelAlignment.set_padding(padding_top = 4, padding_bottom = 10,
Index: src/mlx/i18n.py
===================================================================
--- src/mlx/i18n.py	(revision 123)
+++ src/mlx/i18n.py	(revision 124)
@@ -124,4 +124,9 @@
     def initialize(self):
         """Initialize the strings."""
+        self.add("button_ok", "_OK")
+        self.add("button_cancel", "_Cancel")
+        self.add("button_yes", "_Yes")
+        self.add("button_no", "_No")
+        
         self.add("menu_file", "File")
         self.add("menu_file_quit", "_Quit")
@@ -166,8 +171,7 @@
                  "Then press <b>Reconnect</b> to reconnect.\n\n"
                  "If you want to cancel the flight, press <b>Cancel</b>.")
-        self.add("button_cancel", "_Cancel")
         self.add("button_tryagain", "_Try again")
         self.add("button_reconnect", "_Reconnect")
-        
+
         self.add("login", "Login")
         self.add("loginHelp",
@@ -576,4 +580,9 @@
     def initialize(self):
         """Initialize the strings."""
+        self.add("button_ok", "_OK")
+        self.add("button_cancel", "_Mégse")
+        self.add("button_yes", "_Igen")
+        self.add("button_no", "_Nem")
+        
         self.add("menu_file", "Fájl")
         self.add("menu_file_quit", "_Kilépés")
@@ -621,8 +630,7 @@
                  "Ha meg akarod szakítani a repülést, nyomd meg a "
                  "<b>Mégse</b> gombot.")
-        self.add("button_cancel", "_Mégse")
         self.add("button_tryagain", "_Próbáld újra")
         self.add("button_reconnect", "Újra_kapcsolódás")
-        
+
         self.add("login", "Bejelentkezés")
         self.add("loginHelp",