Index: src/mlx/config.py
===================================================================
--- src/mlx/config.py	(revision 124)
+++ src/mlx/config.py	(revision 131)
@@ -34,6 +34,7 @@
         self._autoUpdate = True        
         self._updateURL = Config.DEFAULT_UPDATE_URL
-
+        
         self._language = ""
+        self._flareTimeFromFS = False
 
         self._modified = False
@@ -88,4 +89,18 @@
 
     @property
+    def flareTimeFromFS(self):
+        """Get whether the flare time should be calculated from the time values
+        returned by the simulator."""
+        return self._flareTimeFromFS
+
+    @flareTimeFromFS.setter
+    def flareTimeFromFS(self, flareTimeFromFS):
+        """Set whether the flare time should be calculated from the time values
+        returned by the simulator."""
+        if flareTimeFromFS!=self._flareTimeFromFS:
+            self._flareTimeFromFS = flareTimeFromFS
+            self._modified = True
+
+    @property
     def autoUpdate(self):
         """Get if an automatic update is needed."""
@@ -126,4 +141,7 @@
 
         self._language = self._get(config, "general", "language", "")
+        self._flareTimeFromFS = self._getBoolean(config, "general",
+                                                 "flareTimeFromFS",
+                                                 False)
         
         self._modified = False
@@ -150,4 +168,6 @@
         if self._language:
             config.set("general", "language", self._language)
+        config.set("general", "flareTimeFromFS",
+                   "yes" if self._flareTimeFromFS else "no")
         
         try:
Index: src/mlx/gui/gui.py
===================================================================
--- src/mlx/gui/gui.py	(revision 130)
+++ src/mlx/gui/gui.py	(revision 131)
@@ -673,4 +673,5 @@
 
         self._flight = flight.Flight(self._logger, self)
+        self._flight.flareTimeFromFS = self.config.flareTimeFromFS
         self._flight.aircraftType = aircraftType
         self._flight.aircraft = acft.Aircraft.create(self._flight)
Index: src/mlx/gui/prefs.py
===================================================================
--- src/mlx/gui/prefs.py	(revision 124)
+++ src/mlx/gui/prefs.py	(revision 131)
@@ -61,4 +61,5 @@
         """Setup the dialog from the given configuration."""
         self._setLanguage(config.language)
+        self._flareTimeFromFS.set_active(config.flareTimeFromFS)
 
         self._togglingAutoUpdate = True
@@ -73,4 +74,5 @@
         """Setup the given config from the settings in the dialog."""
         config.language = self._getLanguage()
+        config.flareTimeFromFS = self._flareTimeFromFS.get_active()
         config.autoUpdate = self._autoUpdate.get_active()
         config.updateURL = self._updateURL.get_text()
@@ -107,8 +109,14 @@
         languageBox.pack_start(languageComboBox, False, False, 4)
 
+        label.set_mnemonic_widget(languageComboBox)
+
         self._changingLanguage = False
         self._warnedRestartNeeded = False
 
-        label.set_mnemonic_widget(languageComboBox)
+        self._flareTimeFromFS = gtk.CheckButton(xstr("prefs_flaretimeFromFS"))
+        self._flareTimeFromFS.set_use_underline(True)
+        self._flareTimeFromFS.set_tooltip_text(xstr("prefs_flaretimeFromFS_tooltip"))
+
+        mainBox.pack_start(self._flareTimeFromFS, False, False, 4)
                                        
         return mainAlignment
Index: src/mlx/i18n.py
===================================================================
--- src/mlx/i18n.py	(revision 130)
+++ src/mlx/i18n.py	(revision 131)
@@ -557,4 +557,9 @@
         self.add("prefs_lang_en_GB", "English")
         self.add("prefs_lang_hu_HU", "Hungarian")
+        self.add("prefs_flaretimeFromFS",
+                 "Take flare _time from the simulator")
+        self.add("prefs_flaretimeFromFS_tooltip",
+                 "If this is checked, the time of the flare will be calculated "
+                 "from timestamps returned by the simulator.")
         self.add("prefs_update_auto", "Update the program auto_matically")
         self.add("prefs_update_auto_tooltip",
@@ -1023,4 +1028,9 @@
         self.add("prefs_lang_en_GB", "angol")
         self.add("prefs_lang_hu_HU", "magyar")
+        self.add("prefs_flaretimeFromFS",
+                 "A ki_lebegtetés idejét vedd a szimulátorból")
+        self.add("prefs_flaretimeFromFS_tooltip",
+                 "Ha ezt bejelölöd, a kilebegtetés idejét a szimulátor "
+                 "által visszaadott időbélyegek alapján számolja a program.")
         self.add("prefs_update_auto",
                  "Frissítsd a programot _automatikusan")